Overview

Chart lets you view a graph of data against time. It replaces an actual chart recorder, which uses pens to trace channels on sheets of paper.

With Chart up to 8 "pens" can be in use at once, i.e. 8 traces may be displayed by each instance of Chart. Each trace is drawn using a series of readings from one channel.

The traces are scrolled from right to left across the window, as if a roll of paper was passing behind the screen. The latest readings always appear at the right of the window and the graph slides to the left to make room. Eventually, the oldest data disappears off to the left. You can draw the chart with either with all traces superimposed on 1axis, or with separate axes for each trace.

Other Windows applications can send commands to Chart by means of Dynamic Data Exchange (DDE).

To chart data:

  1. Configure the hardware by loading a setup file.
  2. Select channels to chart.
  3. Press the Start button.


Configuring the Hardware

You configure the data acquisition hardware simply by sending it a hardware setup file (which was created with the SetupIML program). Before you can chart channels you must choose which setup file to use.

  1. Select Load Hardware Setup from the File menu. A dialogue box appears where you can choose to load a setup file from disk or select one that is already in use by another Windmill application. If the applications have common channels you must specify the same setup file for each.
  2. Select a setup file and it is displayed in the File Name box. Select OK and the file is loaded, the hardware configured and you can now select which channels to connect to Chart. (Alternatively double-click on the desired file or type the name into the File Name box then select OK.)

If you prefer you can load the hardware setup file at the same time you load Chart.


Selecting Channels to Chart

Before you can chart data you must select which channels you want to connect to Chart. Do this in the Channel Connections dialogue which appears:

after you select a hardware setup file, or
  • when you select Inputs from the menu bar.

    Connecting channels

    Initially all channels are unconnected and listed in the left hand list box. To connect a channel select it and choose the Connect button. It will now be displayed in the right hand Connected Channels list box. Alternatively double-click channels to connect them.

    Disconnecting channels

    To disconnect a channel select it from the right hand box and press the Disconnect button. It will swap back to the Unconnected Channels box. Alternatively double-click channels to disconnect them.

    Connecting all channels

    If 8 or less channels are included in the setup you can connect them all by selecting the Connect All button. This button is greyed out if there are more than 8 channels (the maximum number Chart can handle).

    When you select OK all the channels in the Connected Channels box will be linked to Chart and graphed when you press Start.

    After connecting or disconnecting channels the paper advances to a new page and the main window is cleared of any previous graph.

    The Inputs option is disabled until you have loaded a hardware setup file.


Starting the Chart

Press the Start button in the main window. The paper advances to a clean page (any previous chart is erased). Sampling starts and the chart begins.

As sampling progresses the time of sampling is shown on the X axis.

Note that before you can chart any data you should:

  1. Configure the hardware by loading a hardware setup file.
  2. Select channels to chart.


Stopping the Chart

Press the Stop button in the main window. Sampling ends and the paper stops moving. The chart will remain static on the screen until you change settings or press Start, whereupon it is erased.


Printing the Chart

To print a copy of the static chart select Print from the File menu. A dialogue box appears for you to include a title on the print-out.

To select the type of printer, the port it is connected to and other details such as paper size, use the Control Panel program which is supplied as part of Windows. Note that colours that look good on the screen may not come out as well on the printer.

You cannot print a moving chart but can copy it to the Clipboard. Press Alt + PrintScreen any time when Chart is the active window, whether the chart is moving or not. The whole window will be copied to the Clipboard and can then be pasted into word processor or graphics programs. For example paste into the Windows Paintbrush program where you can change the colours and add notes before printing.


Setting Superimposed or Separate Traces

The chart can be drawn either with traces from all channels superimposed on 1 Y axis or each trace completely separate. If traces are separate then you can also choose to highlight channels in alarm.

  1. Stop the chart.
  2. Select Display from the menu bar to call up the Display dialogue box.
  3. Choose either:
    Separate traces - No alarms,
    Separate traces - Alarm notification, or
    Superimposed traces.

If you choose Separate traces - No alarms or Superimposed traces, you can select a different colour for each trace.

If you choose Separate traces - Alarm Notification, you can select colours for no alarm, warning alarm and critical alarm states. (Use SetupIML to specify alarms.) Any alarm levels are shown by tick marks on the Y axis of the chart, in the same colours as the alarm states.


Setting the Colour of the Paper

The paper (chart background) can be either black or white.

  1. Stop the chart.
  2. Select Display from the menu bar.
  3. Choose Black paper or White paper.


Setting the Colours of the Traces

If you've chosen superimposed or separate traces without alarms you can choose different colours for each channel.

If you've chosen separate traces with alarms you can choose 3 different colours for no alarm, warning alarm and critical alarm. For clarity these colours are the same for each channel. To change the colour of a trace:

  1. Stop the chart.
  2. Select Display from the menu bar to call up the Display dialogue box.
  3. Click the arrow at the right of the colour box and select a new colour from the list.
  4. Press the Default button to reset the trace colours to their default values, namely:
Separate traces - no alarms | All trace colours the same as the first one
Separate traces - alarms | Green for no alarm Yellow for warning alarm Red for critical alarm
Superimposed traces | All trace colours different


Setting the Ranges of a Chart

  1. Stop the chart.
  2. Select Ranges from the menu bar - one of two Ranges boxes appears, depending upon whether you selected separate or superimposed traces.

Separate Traces

To set the chart range to the same as the channel range, check the "Auto" box (so a cross or a tick is displayed).

Superimposed Traces

To set the chart range to encompass all the channels' ranges, check the "Use automatic scaling" box.

The maximum and minimum values of the range are shown. To set your own customised range type your chosen maximum and minimum values into the edit boxes.

The maximum and minimum values are used as Y axis labels on the graph, (unless the window is too small to display them). Changing the range causes the paper to advance to a new page. Samples that are outside the range of the chart will be shown as a dotted line along the edge of the chart area.


Setting the Speed of Sampling

  1. Stop the chart.
  2. Select Speed from the menu bar - the Speed dialogue box appears.

An information box shows details of the current paper size and the amount of data that will be shown at the selected speed. You can't alter these details directly, but each time you change the speed they are updated.

Paper speed

Each time Chart takes a new set of readings the "paper" moves slightly to the left, so the speed of sampling can be expressed as paper speed - the rate at which the paper moves across the screen.

The paper speed is in centimetres per second, minute or hour. You can specify any value in the range 0.1 to 10, in increments of one decimal place. These centimetres assumse a certain standardised screen size. They might not correspond to real centimetres on your actual display.

Sampling rate

For added flexibility you can set the sampling rate to Fast, Medium or Slow for any paper speed. Chart uses the Speed and Sampling rate settings to calculate and display the sampling rate in Hertz. This will be between 0.1 and 10Hz.

When you're happy with the speed of sampling select OK. The paper will advance to a new page ready to start sampling at the new speed.


Setting the Title of the Chart Window

You can change the title of the Chart window from "Windmill Chart" to one of your choosing. This is particularly useful when running more than one copy of Chart.

  1. Stop the chart.
  2. Select Display from the menu bar.
  3. Erase the current title and type in a new one.


Setting the Type of Time Labels

You can set how the time labels appear on the X axis.

  1. Stop the chart.
  2. Select Speed from the menu bar - the Speed dialogue box appears.
  3. From the Time labels box choose either time of day or elapsed time in seconds, minutes or hours.


Turning the grid on and off

Turning the Grid Off and On

You can choose whether or not a grid is displayed on the chart. When the grid is on, grey vertical lines are drawn at the time ticks. The number and position of the horizontal lines depends on the space available. Turning the grid on slightly reduces the maximum charting speed.

To turn the grid on or off:

  1. Stop the chart.
  2. Select Display from the menu bar.
  3. Choose Grid On or Grid Off.


Saving Chart's Setup Details

You can save all the details you've specified in Chart and restore them in the future.

  1. Select Save Chart setup from the File menu - a dialogue box appears.
  2. Type a name into the File Name box. There is no need to specify an extension as .wch will be automatically added.
  3. Choose OK and the details are stored in this file in the working directory.

The chart setup file contains these details:

  • name of the hardware setup file to use
  • connected channels
  • separate or superimposed traces
  • alarm indication
  • colour of traces
  • colour of paper
  • grid setting
  • title of window
  • range
  • speed of sampling
  • type of time label
  • the size and position of the window on the screen


Restoring Chart's Setup Details

To restore a previously saved Chart setup

  1. Select Restore Chart Setup from the File menu. A dialogue box appears with a list of all files with a .wch extension in the working directory.
  2. Select a Chart setup file and on choosing OK all the setup details are restored.

If Chart is engaged in a DDE conversation when you restore the setup file, the new DDE Service name will not be loaded.

You can also automatically restore Chart's settings when you load Chart, by including the setup file name in the command line.


Closing Chart

Select the File menu and choose the Exit command. The window will close. You can exit even when Chart is graphing.


Loading the Setup Details Automatically

You can configure Chart to start with either a hardware setup file (*.ims) or a Chart setup file (*.wch) already loaded. So when you start Chart you also configure the hardware, position and size the window, connect channels and set all the charting options. You do this by specifying command line arguments in Windows. To do this:

  1. On the Windows desktop right-click the Chart icon.

  2. Select Properties and choose the Shortcut tab.
  3. Add the setup file name to the Target box.

For example, for an Chart setup file called mysetup.wch, the target will look like this
"C:\Program Files\Windmill Software\Windmill\Chart.exe" Setups\mysetup.wch
The .wch file contains a reference to a .ims file so this will be loaded too.

Automatic Charting

If necessary you can take the automation of Chart one step further, so instead of Chart waiting for you to press Start it begins charting as soon as it is loaded.

In this case add /auto to the command line argument, leaving a space between the file name and /auto:

c:\program files\windmill software\windmill\chart.exe chtsetup.wch /auto


Automatically starting Chart when you switch on the computer

Automatically Starting Charting when you Switch on the Computer

You can fully automate Chart so charting starts as soon as you switch on the computer. To do this, having first saved a Chart setup file, proceed as follows.

  1. Add a Chart setup file and the /AUTO switch to Chart's command line argument

    For details of how to do this see Loading the setup details automatically. When loaded Chart will be fully configured and will automatically begin charting without waiting for you to press Start.

  2. Copy the Chart icon to the StartUp program group:

    In Windows 7

    1. Click the Windows Start button [image] , click All Programs, right-click the Startup folder and select Open.
    2. In Computer [image], open the Windmill Software folder, which by default is in the Program Files (x86) folder.
    3. Right-click Chart. Choose Create Shortcut. This may be placed in the Windows folder or on the desktop.
    4. Drag the shortcut into the Startup folder which is at windows\start menu\programs\startup.

    In Earlier versions of Windmill

    1. Launch Windows Explorer and open the Windmill folder. Copy Chart from the Windmill folder (right click the Chart icon and choose copy).
    2. Open the Windows\Start Menu\Programs\StartUp folder and paste Chart there.


Optimising Chart's Performance

There are 3 ways to increase Chart's speed.

  1. Turn off the grid

    When the grid is turned on (Display menu) Chart's maximum speed is reduced.

  2. Reduce the number of channels being charted.

    The fewer channels connected to Chart (Inputs menu) the greater Chart's maximum speed.

  3. Reduce the number of applications running

    If several programs are running simultaneously the computer may not be able to keep up with all the processing required. Chart may therefore be unable to display all the data and the traces will have gaps in them. If this occurs try to reduce the computer's workload by closing some windows.


Using Several Chart Windows

Each Chart program can display results from up to eight channels. For more than eight channels open another Chart window.

You can chart the same channel in 2 Chart windows, each running at different paper speeds. You can therefore see a detailed short term view in one while the other tracks a long term trend.

The more channels you are sampling, the less the available processor time per channel and so the slower the maximum sample rate.


Altering the IMS setup file

Altering the Hardware Setup File

The hardware setup file (*.ims) is altered by the SetupIML program. You can move to SetupIML and change some of the details in the current setup file, such as the range or units, without closing Chart (although the paper must not be moving and the channels should not be in use by another application). When you next start charting data the affected parameters will be updated.

If you rename a channel that Chart has been using it will be disconnected. Use the Inputs menu to reconnect it.


Resizing, Moving and Minimising

You can move and resize the Chart window in the same way as other Windows applications. Moving windows while charting, however, may lead to missed samples. When you reduce the size of the window the available drawing area is reduced, and some of the information on the Y axis disappears.

You can minimise the window - data will still be collected and displayed when you restore Chart.


Commands

File menu

Load Hardware Setup
Save Chart Setup
Restore Chart Setup
Print Chart
DDE
Exit

Inputs menu

Display menu

Ranges menu

Speed menu


Dynamic Data Exchange (DDE)

DDE is a standard protocol that allows co-operating Windows applications to send commands and data to one another. Chart can only receive commands, it cannot send or receive data.

DDE programs are often referred to as clients and servers. A server responds to requests from a client. Chart always acts as a server.

You should read the manuals for your chosen client program or language to find how to create DDE links. The links must be created by the client program.

Both DDE applications must be loaded before a conversation can begin.

Enabling DDE Support

Windows programs cannot make DDE conversations unless they have a unique DDE Service Name. The first instance of Chart loaded will be given the service name "Chart". To change this, or allocate a service name to another instance of the program, select DDE from the File menu. A dialogue box appears for you to enter a new Service Name.


Controlling Chart from Other Applications

You can send Chart simple instructions over DDE links, using the DDE Execute facility. This allows the applications to be controlled remotely from DDE client applications such as Excel, Visual Basic or Windmill Graphics.

Commands are shown in upper case and their parameters in angled brackets. Parameters should be separated by a single space.

Execute Commands Accepted By Chart

DESTROY

Closes Chart. Equivalent of the Exit command on the File menu.

LOAD <setup file name>

Loads a new setup file. If the setup file is not in the working directory you should specify the complete file path. You could use this command to change the channels being charted.

MAXIMIZE

Makes the Chart window full screen size.

MINIMIZE

Iconises Chart. Equivalent of the Minimize command.

MOVE <x pos> <y pos> <x size> <y size>

Moves and resizes Chart. The co-ordinates are in pixels and refer to the position of the top left hand corner of the window. They are absolute, not relative to the current position. You can omit the size parameters if you don't want to change the dimensions of the window.

For example: Move 5 5

PRINT

Prints a copy of the stationary chart. You could use this command, for example, in an Excel macro to produce a hard copy of a test after its completion.

RESTORE

Restores the Chart to the size it was before it was minimised. Equivalent of the Restore command.

START

Starts charting.

STOP

Stops charting.


Error Messages

Error 20 | No reply received - problem with link to acquisition hardware
Error 22 | Timed out while waiting for reply from hardware
Error 29 | Transmission error
Error 100 | The version of Chart you are running is a demonstration version, it will not log real data.
Error 105 | The hardware failed to supply data.
Error 106 | The hardware failed to configure correctly.
Error 107 | Error in hardware communications.
Error 108 | The input value is out of range.
Error 113 | The hardware configuration is incorrect.
Error 114 | The data is not yet ready - try again later.
Error 311 | The channel name is no longer available.
Error 313 | The channel is not enabled.
Error 314 | The channel cannot supply data.


World Wide Web

Web Site

You can find more information about Windmill Software on the World Wide Web at http://www.windmill.co.uk/.

Every month we publish a free newsletter - Monitor ((ISSN 1472-0221), delivered by e-mail. This gives tips on using Windmill and articles on data acquisition and control. To subscribe visit http://www.windmill.co.uk/newsletter.html.

For easy purchase of extra software modules visit http://www.windmillsoft.com/.

Updates of this Help file will be posted at http://www.windmill.co.uk/help.html.


Your Comments on the Help

Tell us any improvements we could make to our Help files. Could you quickly find what you wanted? Was the explanation clear? Have you any questions? Visit http://www.windmill.co.uk/help.html and fill in the comments form at the bottom of the page.


Licence a Trial Copy of Windmill

Subscribers to our newsletter can download a fully-working, trial version of Windmill and the ComIML serial driver. This lets you collect data from almost any device which plugs into the PC's COM port. At the end of your trial, if you wish to keep using the software, you can purchase a release key for just £50 from our data acquisition shop. This will let you go on using your set-up indefinitely.

To obtain a release key:

  1. Run the Windmill ConfIML program and click the Software button.
  2. You will see a screen showing your software and a Request Key. Make a note of the Request Key.
  3. Go to the Windmill data acquisition shop and add Licence your trial version of Windmill to your shopping cart.
  4. During the checkout process you will be asked for your Request Key. Enter this.
  5. One of our team will send you back your Release Key. Enter this in the ConfIML Software Authorization screen you saw earlier. Your software will be re-enabled and you can continue to use it.

Thank you for using Windmill
http://www.windmill.co.uk/
http://www.windmillsoft.com/


Windmill

Windmill is a suite of data acquisition and control software. It comprises:

Drivers - which handle the low-level communications

ConfIML - which creates a file holding details on which hardware devices are in your system

SetupIML - which creates files telling the other applications how you want the hardware configured

Applications - such as Logger and Chart which perform the data acquisition and control tasks


Windmill

Contacting Windmill

Windmill Software,
PO Box 58,
North District Office,
Manchester,
M8 8QR,
UK
Telephone: +44 (0)161 833 2782
Facsimile: +44 (0)161 833 2190
E-mail: sales@windmill.co.uk
http://www.windmillsoft.com/
http://www.windmill.co.uk/


Using Windows

The picture below gives examples of items found in dialogue boxes. For help on any of these items, move your pointer over the picture and click the left mouse button.

The underlined green links in the Help take you to other, related, topics. The blue links take you further down the same topic. For more help on using Help press F1 on the keyboard.


Contacting Windmill Software

Windmill Software, PO Box 58, North District Office, Manchester, M8 8QR, UK.
Telephone: +44 (0)161 833 2782
Facsimile: +44 (0)161 833 2190
E-mail: sales@windmill.co.uk
http://www.windmillsoft.com/
http://www.windmill.co.uk/

Every month we publish a free newsletter - Monitor (ISSN 1472-0221), delivered by e-mail. This gives tips on using Windmill and articles on data acquisition and control. To subscribe visit http://www.windmill.co.uk/newsletter.html.

For easy purchase of extra software modules visit http://www.windmillsoft.com/.

Updates of this Help file will be posted at http://www.windmill.co.uk/help.html.


(Untitled)

The paper size is the width of the drawing area. This depends on the size of the Chart window.


Dotted White Lines Instead of Solid Traces?

There are 2 reasons why you may get a dotted or broken line on your chart:

  1. The computer is too busy
  2. The readings are out of range
  1. If there are several programs running simultaneously then the computer may not be able to keep up with all the processing required. If your chart has gaps in it try to reduce the workload by reducing the number of programs running. Alternatively, try reducing the paper size or speed in Chart. The trace may also become a dotted line if the computer was completely busy with some other activity, for example while you were repositioning a window on the screen.
  2. If the chart range is smaller than the channel range, any out of range readings will appear as a dotted line on the extreme of the range. You can check this by examining the DDE Panel, if loaded, which displays data numerically. Adjust the range if necessary.


Display Menu

The Display menu calls up a dialogue box where you can choose the display mode, set the paper colour, turn the grid off, set the colour of the traces and choose a new title for the Chart window.

Related topics:

Setting superimposed or separate traces

Setting the colour of the paper

Turning the grid on and off

Setting the colour of the traces

Setting the title of the Chart Window


Contents

Windmill Chart Help Contents

Getting Started

Overview

Configuring the hardware

Selecting channels to chart

Starting the chart

Stopping the chart

Printing the chart

Setting Chart's Display, Range and Speed Options

Setting superimposed or separate traces

Setting the colour of the paper

Setting the colours of the traces

Setting the ranges of a chart

Setting the speed of sampling

Setting the title of the Chart window

Setting the type of time labels

Turning the grid on and off

Saving Chart's Details

Saving Chart's setup details

Restoring Chart's setup details

Resizing, moving and minimising

Closing Chart

Optimising Chart

Loading the setup details automatically

Automatically starting Chart when you switch on the computer

Dotted lines instead of solid traces?

Optimising Chart's performance

Using several Chart windows

Altering the hardware setup file

Reference

Command summary

Dynamic data exchange (DDE)

Controlling Chart from other applications

Error messages

World Wide Web

Your comments on the help


Ranges dialogue box - Superimposed traces

Ranges - Superimposed Traces

Use automatic scaling

The Use automatic scaling box sets a chart range that encompasses all the connected channel ranges, selecting the smallest minimum value and the largest maximum value.

Minimum and Maximum

The maximum and minimum values define the range of input values covered by each trace. These are in the same units as specified in SetupIML. To set your own customised range type your chosen maximum and minimum values into the edit boxes.


Inputs Menu

The Inputs menu calls up a dialogue box where you can select which channels are connected to Chart.

Related topics:

Selecting channels to chart


Speed Menu

The Speed menu calls up a dialogue box where you can specify the sampling rate and the type of time labels.

Related topics:

Setting the speed of sampling

Setting the type of time labels


Service Name

Windows programs cannot make DDE conversations unless they have a unique DDE Service Name. To change or allocate a Service Name to a program choose DDE from the File menu and fill in the dialogue box.


Ranges

Ranges Menu

The Ranges menu calls up a dialogue box where you can select the ranges of the chart.

Related topics:

Setting the ranges of a chart


Speed dialogue box

Speed

The Speed dialogue box lets you change the speed of sampling and set the type of time label.

Information

The Information box shows details of the current paper size and the amount of data that will be shown at the selected speed. You cannot alter these details directly but they will be updated each time you change the speed.

Speed

Each time Chart takes a new set of readings the paper moves slightly to the left, so the speed of sampling can be expressed as paper speed - the rate at which the paper moves across the screen.

The paper speed is in centimetres per second, minute or hour. You can specify any value in the range 0.1 to 10, in increments of one decimal place. These centimetres assume a certain standardised screen size. They might not correspond to real centimetres on your actual display.

You can specify the type of Time labels on the X axis. Choose either time of day or elapsed time in seconds, minutes or hours.

Sampling rate

For added flexibility you can set the sampling rate to Fast, Medium or Slow for any paper speed. Chart uses the Speed and Sampling rate settings to calculate and display the sampling rate in Hertz. This will be between 0.1 and 10Hz.


Author

Windmill Chart Help
designed and written
by Jill Studholme

http://www.studholme.net/


File Menu

Load Hardware Setup

Configures the hardware by sending it a hardware setup file of your choice (an *.ims file).

Related topics

Configuring the hardware

Save Chart Setup

Saves Chart's current settings in a setup file of your choice (a *.wch file).

Related topics:

Saving Chart's setup details

Restore Chart Setup

Loads a previously saved Chart setup file of your choice (a *.wch file).

Related topics:

Restoring Chart's setup details

Print Chart

Prints a copy of the currently displayed static chart.

Related topics:

Printing the chart

DDE

Enables DDE support in Chart.

Related topics:

Dynamic Data Exchange(DDE)

Exit

Closes Chart.

Related topics:

Closing Chart


Ranges dialogue box - Separate traces

Ranges - Separate Traces

Auto

The Auto box sets the range of the trace to be the same as the range of the channel (specified in SetupIML). The minimum and maximum values of the range are shown.

Minimum and Maximum

The minimum and maximum values define the range of input values covered by each trace. These are in the same units as specified in SetupIML. To set your own customised range type your chosen maximum and minimum values into the edit boxes.


Display dialogue box

Display

Here you can choose between several display options.

Display Mode | Paper Colour | Grid Lines | Trace Colours | Default Button | Chart Title

Display mode

Here you can choose to display all traces superimposed on 1 Y axis, or each trace with its own separate axis. Choose:

Separate traces - No alarms,

Separate traces - Alarm notification, or

Superimposed traces.

If you choose Separate traces - No alarms or Superimposed traces, you can select a different colour for each trace.

If you choose Separate traces - Alarm Notification, you can select colours for no alarm, warning alarm and critical alarm states. (Alarms are specified in the SetupIML window.) Any alarm levels are shown by tick marks on the Y axis of the chart, in the same colours as the alarm states.

Paper colour

Select either black or white paper (chart background).

Grid lines

When the grid is on grey vertical lines are drawn at the time ticks. The number and position of the horizontal lines depends on the space available, but there will be either 2, 3 or 5 lines. Turning the grid on slightly reduces the maximum charting speed.

Colours

To change the colour of a trace click on the arrow at the right of the box and select a new colour from the list.

Default button

The Default button resets the trace colours to their default values, namely

Separate traces - no alarmsAll trace colours the same as the first one

Separate traces - alarmsGreen for no alarm
Yellow for warning alarm
Red for critical alarm

Superimposed tracesAll trace colours different

Chart Title

Choose your own title for the Chart window.